#include <bits/stdc++.h>

using namespace std;

#define redirect(name) (					\
		freopen(name ".in", "r", stdin),    \
		freopen(name ".out", "w", stdout)   \
	)

struct EDGE {
	int to, value, next_edge;
};

int heads[2000 + 2];
EDGE edges[2 * 2000 + 2];
int nCurEdgesCount = 1;
int degs[2000 + 2];
int bIsChain = true;

void AddEdge(int from, int to, int value) {
	nCurEdgesCount++;
	edges[nCurEdgesCount].to = to;
	edges[nCurEdgesCount].value = value;
	edges[nCurEdgesCount].next_edge = heads[from];
	heads[from] = nCurEdgesCount;
	
	degs[from]++;
	if (degs[from] > 1)
		bIsChain = false;
}

int n;
int values[2000 + 2];

int arrResult[2000 + 2];

bool bVisit[2000 + 2];
vector<int> vPath;

void dfs_chain(int nIn, int nValueToFind) {
	if (bVisit[nIn])
		return;
	if (values[nIn] == nValueToFind)
		return;
	bVisit[nIn] = true;
	vPath.push_back(nIn);
	for (int i = heads[nIn]; i != 0; i = edges[i].next_edge) {
		dfs_chain(edges[i].to, nValueToFind);
	}
}

int dfs_chain_find_min(int nIn) {
	int nAns;
	
	if (bVisit[nIn])
		return 0x3f3f3f3f;
	bVisit[nIn] = true;
	
	nAns = values[nIn];
	for (int i = heads[nIn]; i != 0; i = edges[i].next_edge) {
		nAns = min(nAns, dfs_chain_find_min(edges[i].to));
	}
	
	bVisit[nIn] = false;
	
	return nAns;
}

void solve_chain(void) {
	/*
	int nCurIndex;
	
	for (int i = 2; i <= nCurEdgesCount; i++) {
		if (values[edges[i].to] == 1) {
			nCurIndex = i;
			break;
		}
	}
	
	arrResult[1] = 1;
	
	nCurIndex = 1;
	for (int i = 1; i <= n; i++) {
		if (arrResult[nCurIndex])
	}
	*/
	
	int nCurIndex;
	
	dfs_chain(1, 1);
	nCurIndex = 1;
	arrResult[nCurIndex] = 1;
	//printf("[Now index = %d]\n", nCurIndex);
	nCurIndex++;
	//printf("[size = %d]\n", (int)vPath.size());
	for (size_t i = 0; i < vPath.size(); i++) {
		arrResult[nCurIndex] = vPath[i];
		nCurIndex++;
	}
	
	//printf("[Now index = %d]\n", nCurIndex);
	
	int times = 0;
	
	while (nCurIndex <= n) {
		int nMinValue;
		
		//printf("[Now index = %d]\n", nCurIndex);
		
		nCurIndex--;
		values[nCurIndex] = arrResult[nCurIndex];
		vPath.clear();
		
		nMinValue = dfs_chain_find_min(nCurIndex);
		//printf("{%d}\n", nMinValue);
		dfs_chain(nCurIndex, nMinValue);
		
		arrResult[nCurIndex] = nMinValue;
		nCurIndex++;
		//printf("[size = %d]\n", (int)vPath.size());
		for (size_t i = 0; i < vPath.size(); i++) {
			arrResult[nCurIndex] = vPath[i];
			nCurIndex++;
		}
		
		if (times++ > 10000) {
			arrResult[nCurIndex] = values[nCurIndex];
			break;
		}
	}
	
	vPath.clear();
}

void MAIN(void) {
	int t;
	
	scanf("%d", &t);
	for (int nLoopedCount = 0; nLoopedCount < t; nLoopedCount++) {
		int a, b;
		
		scanf("%d", &n);
		for (int i = 1; i <= n; i++) {
			scanf("%d", &a);
			values[a] = i;
		}
		
		for (int i = 1; i < n; i++) {
			scanf("%d%d", &a, &b);
			AddEdge(a, b, 0);
			AddEdge(b, a, 0);
		}
	}
	
	if (bIsChain) {
		solve_chain();
		for (int i = 1; i <= n; i++) {
			printf("%d ", arrResult[i]);
		}
	}
	else {
		// ???
		solve_chain();
		for (int i = 1; i <= n; i++) {
			printf("%d ", arrResult[i]);
		}
	}
}

int main(void) {
#if 1
	redirect("tree");
#endif
	MAIN();
	return 0;
}


