#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (n); i ++)
#define rep1(i, n) for(int i = 1; i <= (n); i ++)
 
typedef long long LL;
typedef pair<int, int> PII;

int n, pos[2005], ans[2005];
vector<int> G[2005];
int pre[2005][2005], nxt[2005][2005], con[2005];

bool check(int l, int m, int r)
{
	if(pre[m][r] == -1 || nxt[m][l] == -1 || nxt[m][l] == r) return false;
	if(nxt[m][l] == 0 && pre[m][r] == n + 1 && con[m] != 2) return false;
	return true;
}

void unite(int l, int m, int r)
{
	nxt[m][pre[m][r]] = nxt[m][l];
	pre[m][nxt[m][l]] = pre[m][r];
	pre[m][r] = nxt[m][l] = -1;
	con[m] --;
}

int find_b(int v, int par)
{
	int ret = n;
	if(check(par, v, n + 1)) ret = min(ret, v);
	rep(i, G[v].size()) {
		int u = G[v][i];
		if(u == par) continue;
		if(check(par, v, u)) ret = min(ret, find_b(u, v));
	}
	return ret;
}

bool del_b(int v, int nv, int par)
{
	if(v == nv) {
		unite(par, v, n + 1);
		return true;
	}
	rep(i, G[v].size()) {
		int u = G[v][i];
		if(u == par) continue;
		if(del_b(u, nv, v)) {
			unite(par, v, u);
			return true;
		}
	}
	return false;
}

void solve()
{
	scanf("%d", &n);
	rep1(i, n) {
		G[i].clear();
		rep(j, n + 2) pre[i][j] = nxt[i][j] = j;
	}
	rep1(i, n) scanf("%d", &pos[i]);
	rep(i, n - 1) {
		int u, v;
		scanf("%d%d", &u, &v);
		G[u].push_back(v);
		G[v].push_back(u);
	}
	rep1(i, n) con[i] = G[i].size() + 2;
	
	rep1(i, n) {
		int npos = find_b(pos[i], 0);
		ans[i] = npos;
		del_b(pos[i], npos, 0);
	}
	
	rep1(i, n) printf("%d%c", ans[i], i == n ? '\n' : ' ');
}

int main()
{
#ifndef NON_FILE_IO
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
#endif
	int T;
	scanf("%d", &T);
	while(T --) solve();
	return 0;
}
