#include <cassert>
#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0);
#endif

#ifndef LOCAL
static char buf[1 << 16 | 1], *ptr = buf + (1 << 16);
#define getchar() (ptr == buf + (1 << 16) ? buf[fread(buf, 1, 1 << 16, stdin)] = EOF, *((ptr = buf)++) : *(ptr++))
#endif
inline int readint() {
	int a = 0; char c = getchar(), po = 1;
	while(isspace(c)) c = getchar();
	if(c == '-') c = getchar(), po = 0;
	while(isdigit(c)) a = a * 10 + c - '0', c = getchar();
	return po ? a : -a;
}

typedef long long LL;
const int maxN = 500000 + 5;
int n, a[maxN], pa[20][maxN], f[20][maxN];
int p[maxN], sz[maxN], pre[maxN], post[maxN];
LL ans[maxN];

bool cmp(int x, int y) {
	return a[x] != a[y] ? a[x] < a[y] : x < y;
}

int hop(int u, int val) { // all >= val
	for(int k = 19; k >= 0; --k) {
		int pu = pa[0][u];
		if(f[k][pu] >= val)
			u = pa[k][u];
	}
	return u;
}

int C[maxN];
void add(int p, int x) {
	for(; p <= n; p += p & -p) C[p] += x;
}
int sum(int p) {
	int r = 0;
	for(; p > 0; p -= p & -p) r += C[p];
	return r;
}

int main() {
#ifndef LOCAL
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
#endif
	n = readint();
	{
		char c = getchar();
		while(isspace(c)) c = getchar();
		for(int i = 1; i <= n; ++i) {
			if(c == '(') a[i] = 1;
			else if(c == ')') a[i] = -1;
			else assert(false);
			c = getchar();
		}
	}
	memset(pa, 0, sizeof(pa));
	memset(f, 0, sizeof(f));
	pa[0][1] = 0;
	a[0] = 0;
	for(int i = 2; i <= n; ++i) {
		int p = pa[0][i] = readint();
		a[i] += a[p];
	}
	displaya(a, 0, n);
	f[0][0] = 0;
	for(int u = 1; u <= n; ++u) f[0][u] = a[u];
	for(int k = 1; k < 20; ++k)
		for(int u = 1; u <= n; ++u)
			pa[k][u] = pa[k - 1][pa[k - 1][u]],
			f[k][u] = min(f[k - 1][u], f[k - 1][pa[k - 1][u]]);
	memset(sz, 0, sizeof(sz));
	for(int u = 0; u <= n; ++u) sz[u] = 1;
	for(int u = n; u >= 1; --u) sz[pa[0][u]] += sz[u];
	pre[0] = 0; post[0] = 0;
	for(int u = 1; u <= n; ++u) pre[u] = post[u] = post[pa[0][u]] + 1, post[pa[0][u]] += sz[u];
	displaya(sz, 0, n);
	displaya(pre, 0, n);
	displaya(post, 0, n);
	for(int u = 0; u <= n; ++u) assert(post[u] - pre[u] + 1 == sz[u]);
	for(int u = 0; u <= n; ++u) p[u] = u;
	sort(p, p + n + 1, cmp);
	displaya(p, 0, n);
	memset(C, 0, sizeof(C));
	for(int l = 0; l <= n; ++l) {
		int r = l;
		while(r <= n && a[p[r]] == a[p[l]]) ++r;
		--r;
		eprintf("[%d, %d]\n", l, r);
		for(int i = l; i <= r; ++i) {
			int u = p[i];
			add(pre[u] + 1, +1);
			add(post[u] + 1, -1);
		}
		for(int i = l; i <= r; ++i) {
			int u = p[i];
			int v = hop(u, a[u]);
			eprintf("top(%d) = %d\n", u, v);
			assert(pre[v] <= pre[u] && post[u] <= post[v]);
			if(v == 0) ans[u] = sum(pre[u]);
			else ans[u] = sum(pre[u]) - sum(pre[pa[0][v]]);
			// sum(x) == 0 if x < 0
		}
		for(int i = l; i <= r; ++i) {
			int u = p[i];
			add(pre[u] + 1, -1);
			add(post[u] + 1, +1);
		}
		l = r;
	}
	ans[0] = 0;
	displaya(ans, 0, n);
	assert(ans[0] == 0);
	for(int u = 1; u <= n; ++u) ans[u] += ans[pa[0][u]];
	displaya(ans, 0, n);
	LL sum = 0;
	for(int u = 1; u <= n; ++u) {
		sum ^= (u * ans[u]);
	}
	cout << sum << '\n'; 
	return 0;
}

