#include <cassert>
#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0);
#endif

#ifndef LOCAL
static char buf[1 << 16 | 1], *ptr = buf + (1 << 16);
#define getchar() (ptr == buf + (1 << 16) ? buf[fread(buf, 1, 1 << 16, stdin)] = EOF, *((ptr = buf)++) : *(ptr++))
#endif
inline int readint() {
	int a = 0; char c = getchar(), po = 1;
	while(isspace(c)) c = getchar();
	if(c == '-') c = getchar(), po = 0;
	while(isdigit(c)) a = a * 10 + c - '0', c = getchar();
	return po ? a : -a;
}

const int maxN = 2000 + 5;
int n, id[maxN][maxN];
vector<int> G[maxN];
struct List {
	int m, h, t;
	vector<int> prev, next;
	void resize(int m) {
		this->m = m;
		prev.assign(m, -1);
		next.assign(m, -1);
		h = t = -2;
	}
	void link(int x, int y) {
		assert(next[x] == y || next[x] == -1);
		assert(prev[y] == x || prev[y] == -1);
		assert(x != t); assert(y != h);
		next[x] = y;
		prev[y] = x;
	}
} S[maxN];

bool ok[maxN];
int pa[maxN];
void dfs(int u, int fa) {
	eprintf("dfs %d -> %d\n", fa, u);
	int s = id[u][fa];
	if(S[u].t != s) {
		if(S[u].next[s] >= 0) dfs(G[u][S[u].next[s]], u);
		else {
			int forb1 = -1, forb2 = -1;
			{
				int x = s, cnt = 1;
				while(S[u].prev[x] != -1) x = S[u].prev[x], ++cnt;
				forb1 = x;
				if(x == S[u].h && S[u].t >= 0) {
					x = S[u].t; ++cnt;
					while(S[u].prev[x] != -1) x = S[u].prev[x], ++cnt;
					if(cnt < S[u].m) forb2 = x;
				}
			}
			eprintf("%d: forb = %d, %d\n", u, forb1, forb2);
			for(int i = 0; i < S[u].m; ++i) if(i != S[u].h && S[u].prev[i] == -1 && i != forb1 && i != forb2) {
				dfs(G[u][i], u);
			}
		}
	}
	pa[u] = fa;
	
	bool spe = false;
	{
		int x = s, cnt = 1;
		while(S[u].prev[x] >= 0) x = S[u].prev[x], ++cnt;
		if(cnt < S[u].m && x == S[u].h) spe = true;
	}
	if(!spe && (S[u].t < 0 || S[u].t == s) && S[u].next[s] == -1) ok[u] = true;
}

void link(int t, int s) {
	S[t].t = id[t][pa[t]];
	while(pa[t] != s) {
		int u = pa[t];
		int i = id[u][pa[u]], j = id[u][t];
		S[u].link(i, j);
		t = pa[t];
	}
	S[s].h = id[s][t];
}

int solve(int u) {
	memset(ok, 0, sizeof(ok));
	if(S[u].h >= 0) {
		dfs(G[u][S[u].h], u);
	} else {
		int forb = -1;
		if(S[u].t >= 0) {
			int x = S[u].t, cnt = 1;
			while(S[u].prev[x] != -1) x = S[u].prev[x], ++cnt;
			if(cnt < S[u].m) forb = x;
		}
		for(int i = 0; i < S[u].m; ++i) if(S[u].prev[i] == -1 && i != forb) {
			dfs(G[u][i], u);
		}
	}
	int ans = -1;
	for(int i = 1; i <= n; ++i) if(ok[i]) { ans = i; break; }
	eprintf("%d -> %d\n", u, ans);
	link(ans, u);
	return ans;
}

void run() {
	static int p[maxN];
	n = readint();
	for(int u = 1; u <= n; ++u) G[u].clear();
	for(int u = 1; u <= n; ++u) p[u] = readint();
	displaya(p, 1, n);
	for(int i = 1; i <= n - 1; ++i) {
		int x = readint(), y = readint();
		G[x].push_back(y);
		G[y].push_back(x);
	}
	if(n == 0) {
		cout << '\n'; return;
	} else if(n == 1) {
		cout << "1\n"; return;
	}
	memset(id, -1, sizeof(id));
	for(int i = 1; i <= n; ++i) {
		for(int j = 0; j < (int)G[i].size(); ++j)
			id[i][G[i][j]] = j;
	}
	for(int u = 1; u <= n; ++u) S[u].resize(G[u].size());
	vector<int> ans;
	for(int i = 1; i <= n; ++i) {
		int u = p[i];
		int res = solve(u);
		ans.push_back(res);
	}
	for(int i = 0; i < n; ++i) cout << ans[i] << " \n"[i + 1 == n];
}

int main() {
#ifndef LOCAL
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
#endif
	int T = readint();
	while(T--) {
		run();
	}
	return 0;
}

