#define TASKNAME "brackets"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

size_t read_str(char *s) {
    using namespace _buff;
    size_t ret = 0;
    char c = getc();
    for (; c != '(' && c != ')'; c = getc()) {
        assert(~c);
    }
    for (; c == '(' || c == ')'; c = getc()) {
        s[ret++] = c;
    }
    return ret;
}

const size_t N = 5e5 + 5;
const size_t M = N << 1;
const size_t L = 20;

struct Edge {
    int to, nxt;
    Edge() {}
    Edge(int to, int nxt) : to(to), nxt(nxt) {}
} e[N];

struct Query {
    int id, bound, nxt;
    Query() {}
    Query(int id, int bound, int nxt) :
        id(id), bound(bound), nxt(nxt) {}
} que[N];

int head[N], tot;
int headq[N], totq;

void add_edge(int u, int v) {
    e[++tot] = Edge(v, head[u]);
    head[u] = tot;
}

void add_query(int u, int id, int bound) {
    que[++totq] = Query(id, bound, headq[u]);
    headq[u] = totq;
}

char s[N];
int f[N], sum[N], pa[N], par[L][N], psum[L][N];
LL ans[N];
LL cnt1[M], cnt2[M];

void dfs1(int u, int p = 0) {
    sum[u] = sum[p] + (s[u] == '(' ? 1 : -1);
    assert(0 <= sum[u] && sum[u] < (int) M);
    par[0][u] = p;
    psum[0][u] = min(sum[u], sum[p]);
    for (unsigned i = 1; i < L; ++i) {
        par[i][u] = par[i - 1][par[i - 1][u]];
        psum[i][u] = min(psum[i - 1][u], psum[i - 1][par[i - 1][u]]);
    }
    ans[u] = cnt1[sum[u]];
    ++cnt1[sum[u]];
    for (int i = head[u]; i; i = e[i].nxt) {
        dfs1(e[i].to, u);
    }
    --cnt1[sum[u]];
}

int up(int u, int bound) {
    for (int i = (int) L - 1; i >= 0; --i) {
        if (psum[i][u] >= bound) {
            u = par[i][u];
        }
    }
    return pa[u];
}

void dfs2(int u) {
    ++cnt2[sum[u]];
    for (int i = headq[u]; i; i = que[i].nxt) {
        ans[que[i].id] -= cnt2[que[i].bound];
    }
    for (int i = head[u]; i; i = e[i].nxt) {
        dfs2(e[i].to);
    }
    --cnt2[sum[u]];
}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    sum[0] = (int) N;
    ++cnt1[sum[0]]; ++cnt2[sum[0]];
    int n = read();
    assert((int) read_str(s + 1) == n);
    for (int i = 2; i <= n; ++i) {
        add_edge(pa[i] = read(), i);
    }
    pa[0] = -1;

    dfs1(1);
    for (int i = 1; i <= n; ++i) {
        int j = up(i, sum[i]);
        if (~j) {
            add_query(j, i, sum[i]);
        }
    }
    dfs2(1);

    LL res = 0;
    for (int i = 1; i <= n; ++i) {
        ans[i] += ans[pa[i]];
        res ^= i * ans[i];
    }

    cout << res << '\n';

    return 0;
}
