#define TASKNAME "tree"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

const size_t N = 2e3 + 5;

int n, belong[N], e[N][2];

namespace subtask_1 {

bool is_task() {
    return n <= 10;
}

int id[N], num[N], ans[N];

bool comp(int arr[], int brr[]) {
    for (int i = 1; i <= n; ++i) {
        if (arr[i] != brr[i]) {
            return arr[i] < brr[i];
        }
    }
    return false;
}

void solve() {
    for (int i = 1; i < n; ++i) {
        id[i] = i;
    }
    fill(ans + 1, ans + n + 1, INT_MAX);
    do {
        static int cur[N];
        for (int i = 1; i <= n; ++i) {
            num[belong[i]] = i;
        }
        for (int i = 1; i < n; ++i) {
            int u = e[id[i]][0], v = e[id[i]][1];
            swap(num[u], num[v]);
        }
        for (int i = 1; i <= n; ++i) {
            cur[num[i]] = i;
        }
        if (comp(cur, ans)) {
            copy(cur + 1, cur + n + 1, ans + 1);
        }
    } while (next_permutation(id + 1, id + n));
    for (int i = 1; i <= n; ++i) {
        printf("%d%c", ans[i], "\n "[i < n]);
    }
}

}

/*
namespace subtask_2 {

bool is_task() {
    static int deg[N], cnt[N];
    for (int i = 1; i < n; ++i) {
        ++deg[e[i][0]];
        ++deg[e[i][1]];
    }
    for (int i = 1; i <= n; ++i) {
        ++cnt[deg[i]];
    }
    return cnt[1] == 2 && cnt[2] == n - 2;
}

struct Edge {
    int to, nxt;
    Edge() {}
    Edge(int to, int nxt) : to(to), nxt(nxt) {}
} g[N << 1];

int tot, head[N];

void add_edge(int u, int v) {
    g[++tot] = Edge(v, head[u]);
    head[u] = tot;
}

bool exi[N];
int val[N];

void get_g() {
    tot = 0;
    for (int i = 1; i <= n; ++i) {
        head[i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int u = e[i][0], v = e[i][1];
        if (u != v) {
            cerr << u << " <-> " << v << '\n';
            add_edge(u, v);
            add_edge(v, u);
        }
    }
}

int pa[N];

int dfs1(int u, int p = 0) {
    int ret = p ? u : INT_MAX;
    for (int i = head[u]; i; i = g[i].nxt) {
        if (g[i].to != p) {
            ret = min(ret, dfs1(g[i].to, u));
        }
    }
    return ret;
}

void dfs2(int u, int p = 0) {
    pa[u] = p;
    for (int i = head[u]; i; i = g[i].nxt) {
        if (g[i].to != p) {
            dfs2(g[i].to, u);
        }
    }
}

int ans[N];

void solve() {
    for (int i = 1; i <= n; ++i) {
        val[belong[i]] = i;
    }
    fill(exi + 1, exi + n + 1, true);
    while (true) {
        get_g();
        pair<int, int> mn = make_pair(INT_MAX, -1);
        for (int i = 1; i <= n; ++i) {
            if (exi[i]) {
                mn = min(mn, make_pair(val[i], i));
            }
        }
        int id = mn.second;
        if (!~id) break;
        int root = dfs1(mn.second);
        // cerr << "doit root = " << root << '\n';
        if (root > n) {
            exi[id] = false;
            continue;
        }
        dfs2(root);
        exi[root] = false;
        cerr << "=============== root, id ="  << root << ' ' << id << '\n';
        static bool on_link[N];
        static int ch[N];
        int rid = id;
        memset(on_link, 0, sizeof on_link);
        for (; id != root; id = pa[id]) {
            exi[pa[id]] = false;
            on_link[pa[id]] = true;
            ch[pa[id]] = id;
            swap(val[id], val[pa[id]]);
            cerr << "swapping " << id << ' ' << pa[id] << '\n';
            cerr << "link " << id << '\n';
        }
        for (int i = 1; i < n; ++i) {
            int &u = e[i][0], &v = e[i][1];
            if (u == v) continue;
            // cerr << "doit u, v = " << u << ' ' << v << '\n';
            if (on_link[u] && on_link[v]) {
                if (ch[u] != v) swap(u, v);
                assert(ch[u] == v);
                v = u;
            } else if (on_link[u]) {
                u = rid;
            } else if (on_link[v]) {
                v = rid;
            }
        }
        for (int i = 1; i <= n; ++i) cerr << val[i] << ' '; cerr << '\n';
    }
    for (int i = 1; i <= n; ++i) {
        ans[val[i]] = i;
        cerr << val[i] << ' ';
    }
    cerr << '\n';
    for (int i = 1; i <= n; ++i) {
        printf("%d%c", ans[i], "\n "[i < n]);
    }
}

}
*/

namespace subtask_3 {

bool is_task() {
    return true;
}

struct Edge {
    int to, nxt;
    Edge() {}
    Edge(int to, int nxt) : to(to), nxt(nxt) {}
} g[N << 1];

int tot, head[N];

void add_edge(int u, int v) {
    g[++tot] = Edge(v, head[u]);
    head[u] = tot;
}

bool exi[N];
int val[N];

void get_g() {
    tot = 0;
    for (int i = 1; i <= n; ++i) {
        head[i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int u = e[i][0], v = e[i][1];
        if (u != v) {
            // cerr << u << " <-> " << v << '\n';
            add_edge(u, v);
            add_edge(v, u);
        }
    }
}

int pa[N];

int dfs1(int u, int p = 0) {
    int ret = p ? u : INT_MAX;
    for (int i = head[u]; i; i = g[i].nxt) {
        if (g[i].to != p) {
            ret = min(ret, dfs1(g[i].to, u));
        }
    }
    return ret;
}

void dfs2(int u, int p = 0) {
    pa[u] = p;
    for (int i = head[u]; i; i = g[i].nxt) {
        if (g[i].to != p) {
            dfs2(g[i].to, u);
        }
    }
}

int ans[N];

void solve() {
    for (int i = 1; i <= n; ++i) {
        val[belong[i]] = i;
    }
    fill(exi + 1, exi + n + 1, true);
    while (true) {
        get_g();
        pair<int, int> mn = make_pair(INT_MAX, -1);
        for (int i = 1; i <= n; ++i) {
            if (exi[i]) {
                mn = min(mn, make_pair(val[i], i));
            }
        }
        int id = mn.second;
        if (!~id) break;
        int root = dfs1(mn.second);
        // cerr << "doit root = " << root << '\n';
        if (root > n) {
            exi[id] = false;
            continue;
        }
        dfs2(root);
        exi[root] = false;
        // cerr << "=============== root, id ="  << root << ' ' << id << '\n';
        static bool on_link[N];
        static int ch[N];
        memset(on_link, 0, sizeof on_link);
        on_link[root] = true;
        for (; id != root; id = pa[id]) {
            // on_link[pa[id]] = true;
            ch[pa[id]] = id;
            swap(val[id], val[pa[id]]);
            // cerr << "link " << id << '\n';
        }
        for (int i = 1; i < n; ++i) {
            int &u = e[i][0], &v = e[i][1];
            if (u == v) continue;
            // cerr << "doit u, v = " << u << ' ' << v << '\n';
            if (on_link[u] && on_link[v]) {
                if (ch[u] != v) swap(u, v);
                assert(ch[u] == v);
                v = u;
            } else if (on_link[u]) {
                u = ch[u];
            } else if (on_link[v]) {
                v = ch[v];
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        ans[val[i]] = i;
    }
    for (int i = 1; i <= n; ++i) {
        printf("%d%c", ans[i], "\n "[i < n]);
    }
}

}

void solve() {
    n = read();
    generate_n(belong + 1, n, read);
    for (int i = 1; i < n; ++i) {
        e[i][0] = read();
        e[i][1] = read();
    }

    if (subtask_1::is_task()) {
        subtask_1::solve();
    } else if (subtask_3::is_task()) {
        // cerr << "task 3\n";
        subtask_3::solve();
    }
}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    int t = read();
    while (t--) {
        solve();
    }

    return 0;
}
