#include <stdio.h>
#include <ctype.h>
#include <vector>
using std::vector;

struct Status {
	bool avail;
	vector<int> matched;
	int dep;
	int val;
};

int n, f[500000], k[500000], chain[500000];
char bdata[500001];
Status bstatus[500000];

void init();

template<typename T> void qread(T& t) {
	t = 0;
	char c;
	int symbol = 1;
	while(!isdigit(c = getchar())) {
		if(c == '-') {
			symbol = -1;
		}
	}
	while(isdigit(c)) {
		t = t * 10 + c - '0';
		c = getchar();
	}
	t *= symbol;
}

int getChain(int i) {
	int cur = i, dep = 0;
	for(int p = 0; p < n; ++p) {
		++dep;
		chain[p] = cur;
		if(cur == 0)
			break;
		cur = f[cur];
	}
	return dep;
}

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	init();
	for(int i = 1; i < n; ++i) {
		int len = getChain(i);
		int j;
		for(j = len - 1; j >= 0; --j) {
			if(!bstatus[chain[j]].avail)
				break;
		}
		if(j < 0)
			continue;
		for(; j >= 0; --j) {
			const Status prev = bstatus[chain[j + 1]];
			Status& cstatus = bstatus[chain[j]];
			bstatus[chain[j]] = bstatus[chain[j + 1]];
			cstatus.avail = true;
			if(bdata[chain[j]] == '(') {
				++cstatus.dep;
				cstatus.matched.push_back(0);
			}
			else {
				--cstatus.dep;
				if(cstatus.dep < 0) {
					cstatus.dep = 0;
					cstatus.matched.clear();
					cstatus.matched.push_back(0);
				}
				else {
					cstatus.matched.pop_back();
					++cstatus.matched[cstatus.dep];
					cstatus.val += cstatus.matched[cstatus.dep];
				}
			}
		}
	}
	int ans = bstatus[0].val;
	for(int i = 1; i < n; ++i) {
		ans = ans xor ((i + 1) * bstatus[i].val);
	}
	printf("%d", ans);
	return 0;
}

void init() {
	qread(n);
	scanf("%s", bdata);
	for(int i = 1; i < n; ++i) {
		qread(f[i]);
		--f[i];
	}
	bstatus[0].avail = true;
	bstatus[0].dep = 1;
	bstatus[0].matched.push_back(0);
	bstatus[0].matched.push_back(0);
}
