#include <bits/stdc++.h>
#define foreach(a, b) for (__typeof(a.begin()) b = a.begin(); b != a.end(); b++)

using namespace std;

typedef long long ll;

void fileio() {
    freopen("brackets.in", "r", stdin);
    freopen("brackets.out", "w", stdout);
}

const int MAX_N = 5e5 + 10, INF = INT_MAX;

struct Info {
    int v, cnt;
    Info() {}
    Info(int v, int cnt) : v(v), cnt(cnt) {}
};

Info operator+(const Info &lhs, const Info &rhs) {
    if (lhs.v == rhs.v) return Info(lhs.v, lhs.cnt + rhs.cnt);
    return lhs.v < rhs.v ? lhs : rhs;
}

int A[MAX_N];

struct SegTree {
    Info info;
    int l, r, m;
    SegTree *cl, *cr;

    SegTree(int l, int r) : l(l), r(r), m((l + r) / 2) {
        if (l != r) {
            cl = new SegTree(l, m);
            cr = new SegTree(m + 1, r);
        } else cl = cr = NULL;
        update();
    }

    void update() {
        if (l == r) info = Info(A[l], 1);
        else info = cl->info + cr->info;
    }

    void modify(int x) {
        if (l != r) {
            if (x <= m) cl->modify(x);
            else cr->modify(x);
        }
        update();
    }

    int left_bound(int qr, int qv) {
        if (qr < l || info.v >= qv) return -1;
        if (l == r) return l + 1;
        int t = cr->left_bound(qr, qv);
        if (t != -1) return t;
        return cl->left_bound(qr, qv);
    }

    Info query(int ql, int qr) {
        if (ql > r || qr < l) return Info(INF, 0);
        if (ql <= l && qr >= r) return info;
        return cl->query(ql, qr) + cr->query(ql, qr);
    }
} *segt;

int N, pa[MAX_N];
ll ans[MAX_N];
char S[MAX_N];
vector<int> child[MAX_N];

void dfs(int x, int dep, int lvl) {
    lvl += S[x] == '(' ? 1 : -1;
    A[dep] = lvl;
    segt->modify(dep);
    int l = segt->left_bound(dep, lvl);
    ans[x] = segt->query(l, dep).cnt - 1;
    foreach(child[x], i) {
        dfs(*i, dep + 1, lvl);
    }
}

int main() {
    fileio();
    scanf("%d", &N);
    scanf("%s", S + 1);
    for (int i = 2; i <= N; i++) {
        scanf("%d", &pa[i]);
        child[pa[i]].push_back(i);
    }
    for (int i = 0; i <= N; i++) A[i] = -INF;
    A[1] = 0;
    segt = new SegTree(0, N + 1);
    dfs(1, 2, 0);
    for (int i = 2; i <= N; i++) ans[i] += ans[pa[i]];
    ll digest = 0;
    for (int i = 1; i <= N; i++) digest ^= i * ans[i];
    printf("%lld\n", digest);
}
