#include <bits/stdc++.h>
#define foreach(a, b) for (__typeof(a.begin()) b = a.begin(); b != a.end(); b++)

using namespace std;

void fileio() {
    freopen("tree.in", "r", stdin);
    freopen("tree.out", "w", stdout);
}

const int MAX_N = 2011;

int N, startpoint[MAX_N];
vector<int> edge[MAX_N];

void init() {
    scanf("%d", &N);
    for (int i = 1; i <= N; i++) scanf("%d", &startpoint[i]);
    for (int i = 1; i < N; i++) {
        int a, b; scanf("%d%d", &a, &b);
        edge[a].push_back(b); edge[b].push_back(a);
    }
}

namespace chain {
    bool check() {
        return true;
    }

    int kth[MAX_N], rnk[MAX_N], spk[MAX_N], dir[MAX_N], ans[MAX_N];
    bool gone[MAX_N];

    void solve() {
        int curr = 0;
        for (int i = 1; i <= N; i++)
            if (edge[i].size() == 1) curr = i;
        kth[1] = curr;
        int last = 0;
        for (int i = 2; i <= N; i++) {
            foreach(edge[curr], j) {
                if (*j == last) continue;
                last = curr;
                curr = *j;
                break;
            }
            kth[i] = curr;
        }
        for (int i = 1; i <= N; i++) rnk[kth[i]] = i;
        for (int i = 1; i <= N; i++) spk[i] = rnk[startpoint[i]];
        
        dir[1] = 1;
        dir[N] = -1;

        for (int i = 1; i <= N; i++) {
            int s = spk[i], opt = INT_MAX;
            if (dir[s] != -1) {
                for (int j = s + 1; j <= N; j++) {
                    if (dir[j] != -1 || j == N) {
                        opt = min(opt, kth[j]);
                    }
                    if (dir[j] == 1) break;
                }
            }
            if (dir[s] != 1) {
                for (int j = s - 1; j >= 1; j--) {
                    if (dir[j] != 1 || j == 1) {
                        opt = min(opt, kth[j]);
                    }
                    if (dir[j] == -1) break;
                }
            }
            if (rnk[opt] > s) {
                dir[s] = 1;
                if (rnk[opt] != N) dir[rnk[opt]] = 1;
                for (int j = s + 1; j < rnk[opt]; j++)
                    if (!dir[j]) dir[j] = -1;
            } else {
                dir[s] = -1;
                if (rnk[opt] != 1) dir[rnk[opt]] = -1;
                for (int j = s - 1; j > rnk[opt]; j--)
                    if (!dir[j]) dir[j] = 1;
            }
            ans[i] = opt;
        }

        for (int i = 1; i <= N; i++) printf("%d ", ans[i]);
        printf("\n");
    }

    void clear() {
        for (int i = 1; i <= N; i++) dir[i] = 0, gone[i] = false;
    }

    void main() {
        solve();
        clear();
    }
}

namespace bruteforce {
    bool check() {
        return N <= 10;
    }

    int bi_edge[MAX_N][2], M, curr[MAX_N], ans[MAX_N];
    bool used[MAX_N];

    void update_ans() {
        static int t[MAX_N];
        for (int i = 1; i <= N; i++) t[curr[i]] = i;
        for (int i = 1; i <= N; i++) {
            if (t[i] < ans[i]) break;
            if (t[i] > ans[i]) return;
        }
        for (int i = 1; i <= N; i++) ans[i] = t[i];
    }

    void dfs(int step) {
        if (step == M + 1) {
            update_ans();
        }
        for (int i = 1; i <= M; i++) {
            if (used[i]) continue;
            used[i] = true;
            swap(curr[bi_edge[i][0]], curr[bi_edge[i][1]]);
            dfs(step + 1);
            swap(curr[bi_edge[i][0]], curr[bi_edge[i][1]]);
            used[i] = false;
        }
    }

    void solve() {
        for (int i = 1; i <= N; i++)
            foreach(edge[i], j) {
                if (*j > i) {
                    M++;
                    bi_edge[M][0] = i;
                    bi_edge[M][1] = *j;
                }
            }
        for (int i = 1; i <= N; i++) curr[startpoint[i]] = i, ans[i] = N;
        dfs(1);
        for (int i = 1; i <= N; i++) printf("%d ", ans[i]);
        printf("\n");
    }

    void clear() {
        M = 0;
    }

    void main() {
        solve();
        clear();
    }

}

void clear() {
    for (int i = 1; i <= N; i++) edge[i].clear();
}

int main() {
    fileio();
    int T; scanf("%d", &T);
    for (int i = 1; i <= T; i++) {
        init();
        if (bruteforce::check()) {
            bruteforce::main();
        } else if (chain::check()) {
            chain::main();
        }
        clear();
    }
}
