#include <cstdio>
#include <algorithm>
const int VSZ = 2e3 + 7;
const int ESZ = VSZ * 2;
const int INF = 0x3f3f3f3f;

int n, m, a[VSZ];
int tot, head[VSZ];
struct Edge {
	int from, to, next;
} edge[ESZ];

int pro[VSZ], aa[VSZ], aaa[VSZ], ans[VSZ];

inline void addEdge(int x, int y) {
	edge[++tot].to = y, edge[tot].from = x;
	edge[tot].next = head[x], head[x] = tot;
}

void TInit() {
	tot = 0;
	ans[1] = INF;
	for (int i = 1; i <= n; i++)
		pro[i] = i, head[i] = 0;
}

void eachInit() {
	for (int i = 1; i <= n; i++)
		aa[i] = a[i];
}

// aa[point] = val
// aaa[val] = point;
inline void del(int eid) {
	int x = edge[eid].from, y = edge[eid].to;
	std::swap(aa[x], aa[y]);
}

void work() {
	for (int i = 1; i <= m; i++)
		del(pro[i] * 2);
}

void pre() {
	for (int i = 1; i <= n; i++)
		aaa[aa[i]] = i;
}

void update() {
	pre();
	bool flag = false;
	for (int i = 1; i <= n; i++) {
		if (flag) {
			ans[i] = aaa[i];
			continue;
		}
		if (aaa[i] > ans[i])
			break;
		if (aaa[i] < ans[i]) {
			flag = true;
			ans[i] = aaa[i];
		}
	}
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T--) {
	scanf("%d", &n), m = n - 1;
	for (int i = 1; i <= n; i++)
		scanf("%d", a + i);
	TInit();
	for (int i = 1; i <= m; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		addEdge(x, y), addEdge(y, x);
	}
	do {
		eachInit();
		work();
		update();
	} while (std::next_permutation(pro + 1, pro + m + 1));
	for (int i = 1; i <= n; i++)
		printf("%d ", ans[i]);
	puts("");
}
	return 0;
}

